﻿using System.Data;
using System.Web.UI.WebControls;

namespace CsLib
{
    public class ConnectionLists
    {
        internal static DataRow FindRow(DataTable table, string[] keyNames, object[] keyValues)
        {
            DataView view = table.DefaultView;
            view.Sort = string.Join(",", keyNames);
            view.RowStateFilter = DataViewRowState.CurrentRows;
            DataRowView[] rvs = view.FindRows(keyValues);
            return (rvs.Length == 1) ? rvs[0].Row : null;
        }

        internal static void ClearRow(DataTable table, DataRow row)
        {
            switch (row.RowState){

                case DataRowState.Added:
                    table.Rows.Remove(row);
                    break;
                case DataRowState.Modified:
                    row.Delete();
                    break;
                case DataRowState.Unchanged:
                    row.Delete();
                    break;
            }
        }

        public static void ResolveTable(DataTable table, ListControl listCtl, string listKey, string key, object value)
        {
            foreach (ListItem i in listCtl.Items)
            {
                object[] values = new object[] { value, i.Value };
                DataRow row = FindRow(table, new string[] { key, listKey }, values);
                if (i.Selected && row == null)
                    table.Rows.Add(values);
                else if (!i.Selected && row != null)
                    ClearRow(table, row);
            }
        }

        public static void ResolveList(DataTable table, ListControl listCtl, string listKey, string key, object value)
        {
            foreach (ListItem i in listCtl.Items)
            {
                object[] values = new object[] { value, i.Value };
                DataRow row = FindRow(table, new string[] { key, listKey }, values);
                if (row != null) i.Selected = true;
            }
        }
    }
}
