﻿#light

module FsLib.ConnectionLists

open System.Data
open System.Web.UI.WebControls

type internal Found = None|Some of DataRow

let internal FindRow (table :DataTable) sort (values: obj[]) =
    table.DefaultView.Sort <- sort
    let rows = table.DefaultView.FindRows(values)
    match rows.Length with
    | 0 -> None
    | _ -> Some rows.[0].Row

let internal ClearRow (table :DataTable) (row :DataRow) =
    match row.RowState with
    | DataRowState.Added -> table.Rows.Remove(row)
    | DataRowState.Modified -> row.Delete()
    | DataRowState.Unchanged -> row.Delete()
    | _ -> () 

let public ResolveTable (table :DataTable) (listCtl :ListControl) listKey key value = 
    let commit li =
        let sort = String.concat "," [key;listKey]
        match li with
        | (v,true)  -> match FindRow table sort [| value;(v:>obj) |] with 
                       | None -> do table.Rows.Add([| value;(v:>obj) |])
                       | Some f -> () 
        | (v,false) -> match FindRow table sort [| value;(v:>obj) |] with
                       | None -> () 
                       | Some f -> ClearRow table f      
    [| for i in listCtl.Items -> (i.Value, i.Selected) |] |> Array.iter commit                          

let public ResolveList (table :DataTable) (listCtl :ListControl) listKey key value = 
    let select f = match f with
                   | None -> ()
                   | Some f -> listCtl.Items.FindByValue(f.[listKey:string].ToString()).Selected <- true
    [| for i in listCtl.Items -> [| value;(i.Value:>obj) |] |] 
        |> Array.map ( fun x -> FindRow table (String.concat "," [key;listKey]) x ) |> Array.iter select
    

 