﻿using System;
using System.Data;
using System.Data.SqlClient;

public partial class _Default : System.Web.UI.Page 
{
    DataTable dtCS;
    DataTable dtFS; 

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            ListCS.DataSource = SqlDataSource1;
            ListCS.DataBind();
            ListFS.DataSource = SqlDataSource1;
            ListFS.DataBind();
            SqlDataAdapter ad = new SqlDataAdapter("select * from EmployeeTerritories where EmployeeID=1",
                                     new SqlConnection(@"Data Source=.\SQLEXPRESS;Initial Catalog=Northwind;Integrated Security=True"));
            dtCS = new DataTable();
            dtFS = new DataTable();
            ad.Fill(dtCS);
            ad.Fill(dtFS);
            Session.Add("CS", dtCS);
            Session.Add("FS", dtFS);
        } else{
            dtCS = Session["CS"] as DataTable;
            dtFS = Session["FS"] as DataTable;
        }
    }

    protected override void OnPreRender(EventArgs e)
    {
        if (!IsPostBack)
        {
            CsLib.ConnectionLists.ResolveList(dtCS, ListCS, "TerritoryID", "EmployeeID", 1);
            FsLib.ConnectionLists.ResolveList(dtFS, ListFS, "TerritoryID", "EmployeeID", 1);
        }
        base.OnPreRender(e);
    }


    protected void SaveCS_Click(object sender, EventArgs e)
    {
        dtCS = Session["CS"] as DataTable;
        CsLib.ConnectionLists.ResolveTable(dtCS, ListCS, "TerritoryID", "EmployeeID", 1);
        dtCS.AcceptChanges();
        CsLib.ConnectionLists.ResolveList(dtCS, ListCS, "TerritoryID", "EmployeeID", 1);
        Session.Add("CS", dtCS);
    }

    protected void SaveFS_Click(object sender, EventArgs e)
    {
        dtFS = Session["FS"] as DataTable;
        FsLib.ConnectionLists.ResolveTable(dtFS, ListFS, "TerritoryID", "EmployeeID", 1);
        dtFS.AcceptChanges();
        FsLib.ConnectionLists.ResolveList(dtFS, ListFS, "TerritoryID", "EmployeeID", 1);
        Session.Add("FS", dtFS);
    }
    
}
